.486
.model Flat, Stdcall
option Casemap :None   ; case sensitive

.nolist
include Windows.inc

uselib MACRO libname:req
    include    libname.inc
    includelib libname.lib
ENDM

uselib user32
uselib kernel32
uselib shell32
uselib comctl32
uselib comdlg32
uselib gdi32
uselib masm32   ; for debug
;uselib debug   ; for debug

soff Macro QuotedText:Vararg    ; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

.listall

DlgProc Proto :DWord,:DWord,:DWord,:DWord
inv equ INVOKE

HideTheMenu     equ 2005
ShowTheMenu     equ 2006

.data?
align 4
hWin        dd ?  ; dialog handle
hMenu       dd ?    ; the menu
mi MENUITEMINFO <?>

.code
Program:
    inv InitCommonControls
    inv GetModuleHandle,NULL
    inv DialogBoxParam,eax,101,0,ADDR DlgProc,0
    inv ExitProcess,eax
; -----------------------------------------------------------------------

DlgProc proc uses edi esi ebx hWnd:DWord,uMsg:DWord,wParam:DWord,lParam:DWord
    .if uMsg == WM_COMMAND
        mov eax,wParam
        .if ax==HideTheMenu
            mov mi.cbSize,sizeof mi
            mov mi.fMask,MIIM_ID+MIIM_SUBMENU+MIIM_TYPE+MIIM_STATE  
            inv GetMenuItemInfo,hMenu,10001,FALSE,addr mi  ; 10001 is identifier of File menu
            .if eax==0
                inv GetErrDescription,eax   
            .endif
            inv RemoveMenu,hMenu,10001,MF_BYCOMMAND
            inv DrawMenuBar,hWin
        .elseif ax==ShowTheMenu
            ;inv MessageBox,hWin,soff("showing"),0,0
            mov mi.cbSize,sizeof mi
            mov mi.fMask,MIIM_ID+MIIM_SUBMENU+MIIM_TYPE+MIIM_STATE
            inv InsertMenuItem,hMenu,0,TRUE,addr mi
            .if eax==0
                inv GetErrDescription,eax   
            .endif
            inv DrawMenuBar,hWin
        .endif
    .elseif uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
        inv GetMenu,hWin
        mov hMenu,eax    
    .elseif uMsg == WM_CLOSE
        inv EndDialog,hWin,0
    .endif
    xor eax,eax
    ret
DlgProc Endp

end Program
